'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inputSizes = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-AtomInput-input';
var CLASS_ICON = BASE_CLASS + '--withIcon';
var CLASS_ICON_COMPONENT = CLASS_ICON + '-icon';

var SIZES = {
  MEDIUM: 'm',
  SMALL: 's'
};

var ERROR_STATES = {
  ERROR: 'error',
  SUCCESS: 'success'
};

var Input = function (_Component) {
  (0, _inherits3.default)(Input, _Component);

  function Input() {
    (0, _classCallCheck3.default)(this, Input);
    return (0, _possibleConstructorReturn3.default)(this, (Input.__proto__ || (0, _getPrototypeOf2.default)(Input)).apply(this, arguments));
  }

  (0, _createClass3.default)(Input, [{
    key: 'changeHandler',
    value: function changeHandler(ev, onChange) {
      onChange && onChange({ value: ev.target.value, ev: ev });
    }
  }, {
    key: 'getErrorStateClass',
    value: function getErrorStateClass(errorState) {
      if (errorState) return BASE_CLASS + '--' + ERROR_STATES.ERROR;
      if (errorState === false) return BASE_CLASS + '--' + ERROR_STATES.SUCCESS;
      return '';
    }
  }, {
    key: 'getClassNames',
    value: function getClassNames(_ref) {
      var size = _ref.size,
          charsSize = _ref.charsSize,
          hideInput = _ref.hideInput,
          errorState = _ref.errorState;

      return (0, _classnames2.default)(BASE_CLASS, BASE_CLASS + '-' + size, charsSize && BASE_CLASS + '--size', hideInput && BASE_CLASS + '--hidden', this.getErrorStateClass(errorState));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          checked = _props.checked,
          disabled = _props.disabled,
          hideInput = _props.hideInput,
          id = _props.id,
          name = _props.name,
          onBlur = _props.onBlur,
          _onChange = _props.onChange,
          placeholder = _props.placeholder,
          reference = _props.reference,
          size = _props.size,
          errorState = _props.errorState,
          type = _props.type,
          LeftIcon = _props.leftIcon,
          value = _props.value,
          charsSize = _props.charsSize;


      var LeftIconBlock = function LeftIconBlock() {
        return _react2.default.createElement(
          'span',
          { className: CLASS_ICON_COMPONENT },
          _react2.default.createElement(LeftIcon, null)
        );
      };
      return _react2.default.createElement(
        'span',
        { className: (0, _classnames2.default)(LeftIcon && CLASS_ICON) },
        LeftIcon && _react2.default.createElement(LeftIconBlock, null),
        _react2.default.createElement('input', {
          className: this.getClassNames({
            size: size,
            charsSize: charsSize,
            hideInput: hideInput,
            errorState: errorState
          }),
          checked: checked,
          disabled: disabled,
          id: id,
          name: name,
          onChange: function onChange(ev) {
            return _this2.changeHandler(ev, _onChange);
          },
          onBlur: onBlur,
          placeholder: placeholder,
          ref: reference,
          type: type,
          value: value,
          size: charsSize
        })
      );
    }
  }]);
  return Input;
}(_react.Component);

Input.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /* This Boolean attribute prevents the user from interacting with the input */
  disabled: _propTypes2.default.bool,
  /* Mark the input as selected */
  checked: _propTypes2.default.bool,
  /* The DOM id global attribute. */
  id: _propTypes2.default.string,
  /* sets the name property of an element in the DOM */
  name: _propTypes2.default.string,
  /* onBlur callback */
  onBlur: _propTypes2.default.func,
  /* onChange callback */
  onChange: _propTypes2.default.func,
  /* A hint to the user of what can be entered in the control. The placeholder text must not contain carriage returns or line-feeds. */
  placeholder: _propTypes2.default.string,
  /* 's' or 'm', default: 'm' */
  size: _propTypes2.default.oneOf((0, _values2.default)(SIZES)),
  /* width of input based in number of characters (native "size" attribute) */
  charsSize: _propTypes2.default.number,
  /* text, password, date or number */
  type: _propTypes2.default.string,
  /* value of the control */
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool]),
  /* react ref to access DOM node */
  reference: _propTypes2.default.func,
  /** Wether to show the input or not */
  hideInput: _propTypes2.default.bool,
  /* Will set a red/green border if set to true/false */
  errorState: _propTypes2.default.bool,
  /* Left Icon */
  leftIcon: _propTypes2.default.any
} : {} : {};

Input.defaultProps = {
  size: SIZES.MEDIUM
};

exports.default = Input;
exports.inputSizes = SIZES;